Attribute VB_Name = "dkmReply"
Option Explicit
Const ReplayButtonIndex = 6
Const ReplayAllButtonIndex = 7
Const CITATELINELENGTH = 64
Const TimeoutBeforeAddresSet = 13
Const TimeoutBeforeSend = 8
Const AssumedLang = -1 'for Check_Grammar
Const REFWprefix = ": "
Const EndBodyString = "-- " '     (like TheBat)
Const doReplay = 1
Const doReplayAll = 2
Const CheckLanguage = True 'False
' default language (0 - , 1 - english)
Const DefLanguage = 0
'greetings
Const ruGreeting = ", %name%."
Const enGreeting = "Hello, %name%."
'blah-blah
Const ruStrings = "   [%subj%]  %date%,   :"
Const enStrings = "On your message [%subj%] of %date% I can say the next:"
'signatures
Const ruDefSignature = "" ' . "" & vbCrLf & ""
Const enDefSignature = "Best regards" & vbCrLf & _
    "Konstantin M.dyakov" & vbCrLf & vbCrLf & _
    "mailto:dyakov.home@inetcomm.ru" & vbCrLf & _
    "mailto:dkms@pisem.net"
Const ruDAYS = "      "
Const enDAYS = "Sun Mon Tu Wed Thu Fri Sat"
'Folder for autosaved contacts ( ,  )
Const ContactFolderName = ""
Const SavePrefixInField = "BillingInformation"
Const DefPrefixField = "AnsPrefix"
'Others string fields:
'BillingInformation, Categories, Companies, MessageClass, Mileage, VotingOptions, VotingResponse

Sub dkmReplay(Letter As MailItem, WhatToDo As Long)
Dim Sendername As String, LetterStrings, singleLine
Dim Signature As String
Dim Answer As MailItem, AnswerStrings, AnswerBody, Prefix, AnswerOption
Dim Shell As WshShell, ScriptName As String
Dim SetAddressingPermissionsProcess As WshExec, prLog As String
Dim Greeting, Strings, Signatures, lng As Long
Err.Clear
Greeting = Array(ruGreeting, enGreeting)
Strings = Array(ruStrings, enStrings)
Signatures = Array(ruDefSignature, enDefSignature)
lng = 1 'english
If CheckLanguage Then '  
    '    
    If (Letter.Subject & Letter.body) Like "*[]*" Then
      lng = 0 'russian
    End If
Else
    lng = DefLanguage
End If
AnswerOption = Letter.Actions.Item(1).ReplyStyle
If Signatures(lng) <> "" Then
    Letter.Actions.Item(1).ReplyStyle = olOmitOriginalText
    Signature = Signatures(lng)
Else
    Letter.Actions.Item(1).ReplyStyle = olIncludeOriginalText
    Signature = ""
End If
Select Case WhatToDo
  Case doReplay: Set Answer = Letter.Reply
  Case doReplayAll: Set Answer = Letter.ReplyAll
  Case Else
    MsgBox "Wrong Call of dkmReplay procedure", vbCritical + vbSystemModal
    Exit Sub
End Select
If Signature = "" Then
    Signature = ExtractSignature(Answer.body)
End If
'
Set Shell = New WshShell
ScriptName = SetAddressingPermissionsScript
Set SetAddressingPermissionsProcess = Shell.Exec("wscript.exe """ + ScriptName + """")
On Error Resume Next
Sendername = Letter.SentOnBehalfOfName 'Sendername
If Sendername = "" Then
  SetAddressingPermissionsProcess.Terminate
  Set SetAddressingPermissionsProcess = Nothing
  Set SetAddressingPermissionsProcess = Shell.Exec("wscript.exe """ + ScriptName + """")
  Sendername = Letter.Sendername 'SentOnBehalfOfName
End If
If Err.Number <> 0 Then
    MsgBox "Try once more!!", vbCritical + vbOKOnly, "Obstinate Outlook"
End If
SetAddressingPermissionsProcess.Terminate
Set SetAddressingPermissionsProcess = Nothing
Letter.Actions.Item(1).ReplyStyle = AnswerOption
Prefix = FIO(Sendername) & "> "
If SavePrefixInField = "" Then
  Answer.UserProperties.Add DefPrefixField, olText
  Answer.UserProperties.Item(DefPrefixField).Value = Prefix
Else
  Answer.ItemProperties.Item(SavePrefixInField).Value = Prefix
End If
Answer.BodyFormat = olFormatPlain
Answer.body = Replace(Greeting(lng), "%name%", Sendername) & vbCrLf & vbCrLf
Answer.body = Answer.body & _
  Replace( _
  Replace( _
  Strings(lng), "%date%", dkmDateFormat(Letter.ReceivedTime, lng)), _
  "%subj%", Trim(Mid(Letter.Subject, InStr(Letter.Subject, REFWprefix) + 1))) _
  & vbCrLf & vbCrLf
AnswerBody = Letter.body
AnswerStrings = Split(AnswerBody, vbCrLf)
AnswerBody = ""
If ContactFolderName <> "" Then ' save contact
    On Error GoTo Saved
    Dim oCont As ContactItem
    Dim cName As String, cAddr As String, cFolder As MAPIFolder, cItem As ContactItem
    cName = Answer.Recipients.Item(1).Name
    cAddr = Answer.Recipients.Item(1).Address
    'Find folder
    For Each cFolder In Application.GetNamespace("MAPI").GetDefaultFolder(olFolderContacts).Folders
        If UCase(cFolder.Name) = UCase(ContactFolderName) Then
            'folder is founded then find contact
            For Each cItem In cFolder.Items
                If UCase(Trim(cItem.FullName)) = UCase(Trim(cName)) Then GoTo Saved 'no duplicate
            Next
            Set oCont = cFolder.Items.Add(olContactItem)
            oCont.FullName = cName
            oCont.Email1Address = cAddr
            'Debug.Print cName, cAddr
            oCont.Save
            Exit For
        End If
    Next
End If
Saved: 'or not
Dim prevBlank: prevBlank = False
For Each singleLine In AnswerStrings
  If singleLine = EndBodyString Then Exit For
  If Not (prevBlank And singleLine = "") Then
    prevBlank = (singleLine = "")
    Answer.body = Answer.body & Prefix & singleLine & vbCrLf
  End If
Next
'Add Signature
Answer.body = Answer.body & vbCrLf & _
    EndBodyString & vbCrLf & _
    Replace(Signature, EndBodyString, "")
If Trim(Signature) <> "" Then
    Answer.body = Answer.body & vbCrLf & vbCrLf & _
    Now & ", " & Application.Name & " " & Split(Application.Version, ".")(0)
End If
Answer.Display
'Shell.SendKeys "^{HOME}{DEL 2}" 'for XP
'  ,    ,  -  
If Trim(Signature) = "" Then
    Shell.SendKeys "^{END}{HOME}"
Else
    Shell.SendKeys "^{HOME}{DOWN 3}" 'for 2k3
End If
On Error Resume Next
Kill ScriptName
End Sub

Function FIO(ByVal s As String) As String
Dim retval, wrd, ch
For Each ch In Array("@", ".", "-", "(", ")", "[", "]", "{", "}")
  s = Replace(s, ch, " ")
Next
retval = ""
For Each wrd In Split(s)
  retval = retval & Left(wrd, 1)
Next
If Len(retval) = 1 Then retval = Left(s, 3)
FIO = Left(retval, 3)
End Function

Function dkmDateFormat(d As Date, lng As Long) As String
Dim DAYS
DAYS = Array(ruDAYS, enDAYS)
If lng < 0 Or lng > 1 Then lng = 0
dkmDateFormat = _
  Split(DAYS(lng))(DatePart("w", d) - 1) & ", " & _
  Format(d, "dd.mm.yyyy") & "(" & _
  Format(d, "HH:MM") & ")"
End Function
Function TrimWS(str As String) As String
Dim st As String: st = str
Dim WS As String: WS = "[" & vbCrLf & vbCr & vbLf & vbTab & vbVerticalTab & " ]"
Do While st <> "" And Mid(st, 1, 1) Like WS
    st = Mid(st, 2)
Loop
Do While st <> ""
    If Mid(st, Len(st), 1) Like WS Then
        st = Mid(st, 1, Len(st) - 1)
    Else
        Exit Do
    End If
Loop
TrimWS = st
End Function
Function SetAddressingPermissionsScript() As String
Dim FileName, fs As New FileSystemObject, script As TextStream
Do
  FileName = fs.BuildPath(Environ("TEMP"), fs.GetTempName & ".vbs")
Loop Until Not fs.FileExists(FileName)
FileName = fs.GetAbsolutePathName(FileName)
Set script = fs.CreateTextFile(FileName, True, False)
script.WriteLine "set WshShell=WScript.CreateObject(""WScript.Shell"")"
script.WriteLine "dt = 101: activated = False: Time2wait = " & CStr(1000 * TimeoutBeforeAddresSet)
script.WriteLine "Do While (Not activated And Time2wait > 0)"
script.WriteLine "  activated = WshShell.AppActivate(""Microsoft Outlook"")"
script.WriteLine "  WScript.Sleep (dt): Time2wait = Time2wait - dt"
script.WriteLine "Loop"
script.WriteLine "If Time2Wait >= 0 Then"
script.WriteLine "  WScript.Sleep(100): WshShell.SendKeys(""{TAB 2} {TAB 2}{ENTER}"")"
script.WriteLine "Else"
script.WriteLine "  Call WshShell.Popup(""Safety Window not found!!!"",600,""Error"",48)"
script.WriteLine "End If"
script.Close
SetAddressingPermissionsScript = FileName
End Function 'SetAddressingPermissions

Sub RedefineButtonsInExplorer() '   
Dim bar As CommandBar
Set bar = ActiveExplorer.CommandBars("standard")
If MsgBox("Change action for button '" & Replace(bar.Controls(ReplayButtonIndex).Caption, "&", "") & "' to 'dkmReplayE'?", vbQuestion + vbYesNo) = vbYes Then
  ActiveExplorer.CommandBars("standard").Controls(ReplayButtonIndex).OnAction = "dkmReplayE"
End If
If MsgBox("Change action for button '" & Replace(bar.Controls(ReplayAllButtonIndex).Caption, "&", "") & "' to 'dkmReplayAllE'?", vbQuestion + vbYesNo) = vbYes Then
  ActiveExplorer.CommandBars("standard").Controls(ReplayAllButtonIndex).OnAction = "dkmReplayAllE"
End If
End Sub

Sub dkmReplayI()
Dim Item As Object
Set Item = ActiveInspector.CurrentItem
If Item.Class = olMail Then
  dkmReplay Item, doReplay
Else
  MsgBox "This procedure for eMail Only !!!", vbCritical + vbSystemModal, "Wrong Item Type"
End If
End Sub

Sub dkmReplayAllI()
Dim Item As Object
Set Item = ActiveInspector.CurrentItem
If Item.Class = olMail Then
  dkmReplay Item, doReplayAll
Else
  MsgBox "This procedure for eMail Only !!!", vbCritical + vbSystemModal, "Wrong Item Type"
End If
End Sub

Sub dkmReplayE()
Dim Item As Object, Letter As Object
If ActiveExplorer.Selection.Count > 0 Then
  Set Item = ActiveExplorer.Selection.Item(1)
Else
  MsgBox "Select any eMail first !!!", vbInformation, "Smart Replay"
  Exit Sub
End If
If Item.Class = olMail Then
  dkmReplay Item, doReplay
Else
  MsgBox "This procedure for eMail Only !!!", vbCritical + vbSystemModal, "Wrong Item Type"
End If
End Sub

Sub dkmReplayAllE()
Dim Item As Object, Letter As Object
If ActiveExplorer.Selection.Count > 0 Then
  Set Item = ActiveExplorer.Selection.Item(1)
Else
  MsgBox "Select any eMail first !!!", vbInformation, "Smart Replay"
  Exit Sub
End If
If Item.Class = olMail Then
  dkmReplay Item, doReplayAll
Else
  MsgBox "This procedure for eMail Only !!!", vbCritical + vbSystemModal, "Wrong Item Type"
End If
End Sub

Function GetPrefix(Letter As MailItem) As String
' ,    .
On Error GoTo ErrGetPrefix
If SavePrefixInField = "" Then
  GetPrefix = Letter.UserProperties.Item(DefPrefixField).Value
Else
  GetPrefix = Letter.ItemProperties.Item(SavePrefixInField).Value
End If
Exit Function
ErrGetPrefix:
    GetPrefix = ""
End Function
Function ExtractSignature(body As String) As String
Dim divider As String, DividerExists As Boolean, sign As String, str
divider = "----*----" '"-----Original Message-----" etc.
sign = "": DividerExists = False
For Each str In Split(body, vbCrLf)
    If str Like divider Then
        DividerExists = True
        Exit For
    Else
        sign = sign & str & vbCrLf
    End If
Next
If DividerExists Then
    ExtractSignature = TrimWS(sign)
Else
    ExtractSignature = ""
End If
End Function
